from pathlib import Path
import pandas as pd
from shutil import copyfile
import random
import glob
import os


os.chdir(sti_til_mappe)
if os.path.isdir('train/0.0') is False:
    os.makedirs('train/0.0')
    os.makedirs('train/0.5')
    os.makedirs('train/1.0')
    os.makedirs('train/1.5')
    os.makedirs('train/2.0')
    os.makedirs('train/2.5')
    os.makedirs('train/3.0')
    os.makedirs('test/0.0')
    os.makedirs('test/0.5')
    os.makedirs('test/1.0')
    os.makedirs('test/1.5')
    os.makedirs('test/2.0')
    os.makedirs('test/2.5')
    os.makedirs('test/3.0')

klasser = [
    '0.0',
    '0.5',
    '1.0',
    '1.5',
    '2.0',
    '2.5',
    '3.0',
    # '9.9',
    ]


def tell_per_klasse():
    for k in klasser:
        filer = [f for f in Path(sti_til_mappe).glob('*.png')]
        antall = len([f for f in filer if f.stem.startswith(k)])
        print(f'Det er {antall:4d} filer i "{k}".')


def finn_n_per_klasse(n):
    dictut = {}
    for k in klasser:
        filer = [f for f in Path(sti_til_mappe).glob('*.png') if f.stem.startswith(k)]
        dictut[k] = random.sample(filer, n)
    return dictut


def kopier_nm_per_klasse(n, m):
    # n treningsfiler og m testfiler
    dictut = {}
    for k in klasser:
        filer = [f for f in Path('sti_til_mappe).glob('*.png') if f.stem.startswith(k)]
        dictut[k] = random.sample(filer, n + m)

    for k in klasser:
        tren = dictut[k][:n]
        test = dictut[k][n:]

        for f in tren:
            f = f.resolve()
            utf = Path('train') / k / f.name
            copyfile(f, utf)
            print(f'Kopierte {utf}')
        for f in test:
            f = f.resolve()
            utf = Path('test') / k / f.name
            copyfile(f, utf)
            print(f'Kopierte {utf}')





if __name__ == '__main__':

    print('Hellow!')
    #lag_mapper()
    tell_per_klasse()
    for k, v in finn_n_per_klasse(3).items():
        print(k, v)

    kopier_nm_per_klasse(36, 10)
